The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Iir Class Reference

STK general infinite impulse response filter class. More...

`#include <Iir.h>`

Inheritance diagram for stk::Iir:

## Public Member Functions
| Iir (void)
| Default constructor creates a zero-order pass-through "filter".
| Iir (std::vector< StkFloat > &bCoefficients, std::vector< StkFloat > &aCoefficients)
| Overloaded constructor which takes filter coefficients.
| ~Iir (void)
| Class destructor.
void | setCoefficients (std::vector< StkFloat > &bCoefficients, std::vector< StkFloat > &aCoefficients, bool clearState=false)
| Set filter coefficients.
void | setNumerator (std::vector< StkFloat > &bCoefficients, bool clearState=false)
| Set numerator coefficients.
void | setDenominator (std::vector< StkFloat > &aCoefficients, bool clearState=false)
| Set denominator coefficients.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK general infinite impulse response filter class.

This class provides a generic digital filter structure that can be used to implement IIR filters. For filters containing only feedforward terms, the Fir class is slightly more efficient.

In particular, this class implements the standard difference equation:

a[0]*y[n] = b[0]*x[n] + ... + b[nb]*x[n-nb] - a[1]*y[n-1] - ... - a[na]*y[n-na]

If a[0] is not equal to 1, the filter coeffcients are normalized by a[0].

The gain parameter is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. This structure results in one extra multiply per computed sample, but allows easy control of the overall filter gain.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Iir()

stk::Iir::Iir | ( | std::vector< StkFloat > & | bCoefficients,
|  | std::vector< StkFloat > & | aCoefficients
| ) |  |

Overloaded constructor which takes filter coefficients.

An StkError can be thrown if either of the coefficient vector sizes is zero, or if the a[0] coefficient is equal to zero.

## Member Function Documentation

## ◆ setCoefficients()

void stk::Iir::setCoefficients | ( | std::vector< StkFloat > & | bCoefficients,
|  | std::vector< StkFloat > & | aCoefficients,
|  | bool | clearState = `false`
| ) |  |

Set filter coefficients.

An StkError can be thrown if either of the coefficient vector sizes is zero, or if the a[0] coefficient is equal to zero. If a[0] is not equal to 1, the filter coeffcients are normalized by a[0]. The internal state of the filter is not cleared unless the clearState flag is `true`.

## ◆ setNumerator()

void stk::Iir::setNumerator | ( | std::vector< StkFloat > & | bCoefficients,
|  | bool | clearState = `false`
| ) |  |

Set numerator coefficients.

An StkError can be thrown if coefficient vector is empty. Any previously set denominator coefficients are left unaffected. Note that the default constructor sets the single denominator coefficient a[0] to 1.0. The internal state of the filter is not cleared unless the clearState flag is `true`.

## ◆ setDenominator()

void stk::Iir::setDenominator | ( | std::vector< StkFloat > & | aCoefficients,
|  | bool | clearState = `false`
| ) |  |

Set denominator coefficients.

An StkError can be thrown if the coefficient vector is empty or if the a[0] coefficient is equal to zero. Previously set numerator coefficients are unaffected unless a[0] is not equal to 1, in which case all coeffcients are normalized by a[0]. Note that the default constructor sets the single numerator coefficient b[0] to 1.0. The internal state of the filter is not cleared unless the clearState flag is `true`.

## ◆ tick() [1/2]

StkFrames & stk::Iir::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

136{
137#if defined(_STK_DEBUG_)
138 if ( channel >= frames.channels() ) {
139 oStream_ << "Iir::tick(): channel and StkFrames arguments are incompatible!";
140 handleError( StkError::FUNCTION_ARGUMENT );
141 }
142#endif
143
144 StkFloat *samples = &frames[channel];
145 size_t i;
146 unsigned int hop = frames.channels();
147 for ( unsigned int j=0; j<frames.frames(); j++, samples += hop ) {
148 outputs_[0] = 0.0;
149 inputs_[0] = gain_ * *samples;
150 for ( i=b_.size()-1; i>0; i-- ) {
151 outputs_[0] += b_[i] * inputs_[i];
152 inputs_[i] = inputs_[i-1];
153 }
154 outputs_[0] += b_[0] * inputs_[0];
155
156 for ( i=a_.size()-1; i>0; i-- ) {
157 outputs_[0] += -a_[i] * outputs_[i];
158 outputs_[i] = outputs_[i-1];
159 }
160
161 *samples = outputs_[0];
162 }
163
164 lastFrame_[0] = *(samples-hop);
165 return frames;
166}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::Iir::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

169{
170#if defined(_STK_DEBUG_)
171 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
172 oStream_ << "Iir::tick(): channel and StkFrames arguments are incompatible!";
173 handleError( StkError::FUNCTION_ARGUMENT );
174 }
175#endif
176
177 StkFloat *iSamples = &iFrames[iChannel];
178 StkFloat *oSamples = &oFrames[oChannel];
179 size_t i;
180 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
181 for ( unsigned int j=0; j<iFrames.frames(); j++, iSamples += iHop, oSamples += oHop ) {
182 outputs_[0] = 0.0;
183 inputs_[0] = gain_ * *iSamples;
184 for ( i=b_.size()-1; i>0; i-- ) {
185 outputs_[0] += b_[i] * inputs_[i];
186 inputs_[i] = inputs_[i-1];
187 }
188 outputs_[0] += b_[0] * inputs_[0];
189
190 for ( i=a_.size()-1; i>0; i-- ) {
191 outputs_[0] += -a_[i] * outputs_[i];
192 outputs_[i] = outputs_[i-1];
193 }
194
195 *oSamples = outputs_[0];
196 }
197
198 lastFrame_[0] = *(oSamples-oHop);
199 return iFrames;
200}

The documentation for this class was generated from the following file:

- Iir.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.